#!/bin/bash

[ "$(whoami)" = "root" ] && SUDO="sudo -u wms" || SUDO=""

# make a check before starting envelope a letter
res=$(df -l 2>/dev/null |awk '/\/dev\/shm$/{printf($4)}')
if [ $res -le 10240 ]; then
	echo "No space left in /dev/shm"

	if [ ! -d /tmp/monit ]; then
		$SUDO mkdir -p /tmp/monit || continue
	fi

	sudo chown wms.wms -R /tmp/monit

	touch /tmp/monit/monit.log
	
	# write to monit.log
	echo "[$(date +'%Z %b %d %H:%M:%S')] error    : 'wms_msmtp' no space left for mails" >> /tmp/monit/monit.log
	exit 1
fi

# get company id
if [ -z "$1" -a -z "$com_id" ]; then
	com_id=0
elif [ -n "$1" ]; then
	com_id=$1
fi

QUEUEDIR=/var/spool/mail/$com_id

# Set secure permissions on created directories and files
umask 077

# Change to queue directory (create it if necessary)
if [ ! -d "$QUEUEDIR" ]; then
	$SUDO mkdir -p "$QUEUEDIR" || exit 1
fi
sudo chown wms.wms -R $QUEUEDIR
cd "$QUEUEDIR" || exit 1

# Create new unique filenames of the form
# MAILFILE:  ccyy-mm-dd-hh.mm.ss[-x].mail
# MSMTPFILE: ccyy-mm-dd-hh.mm.ss[-x].msmtp
# where x is a consecutive number only appended if you send more than one
# mail per second.
BASE="`date +%Y-%m-%d-%H.%M.%S`-$RANDOM"

if [ -f "$BASE.mail" -o -f "$BASE.msmtp" ]; then
	TMP="$BASE"
	i=1
	while [ -f "$TMP-$i.mail" -o -f "$TMP-$i.msmtp" ]; do
		i=`expr $i + 1`
	done
	BASE="$BASE-$i"
fi
MAILFILE="$BASE.mail"
MSMTPFILE="$BASE.msmtp"

cat | $SUDO tee "$MAILFILE" >/dev/null || exit 1

# Write command line to $MSMTPFILE
# Write the mail to $MAILFILE

# check attach in mails to get cases
# - voicemail, recording - wav
# - faxes - tiff
# - feedback, text - non the both

if [ $(grep "Content-Type.*image/tiff" "$MAILFILE" -i -c ) -ne 0 ]; then
	# tiff, faxing
	P="fax"
elif [ $(grep "Content-Type.*audio/x-wav" "$MAILFILE" -i -c ) -ne 0 ]; then
	# recording or voi44cemail
	P="wav"
else
	# just a text
	P="txt"
fi

if [ $(echo "$@" | grep '\-\-' -c) -eq 0 ]; then
	# get mail form mail source
    sed -ne "s/To.*<\(.*\)>/ -- \1/p" "$MAILFILE" | $SUDO tee "$MSMTPFILE" > /dev/null

	# correcting From line
	if [ -f "/etc/companies.d/$com_id/msmtprc" ]; then
		fromline=$(sed -ne 's/from \([@]*\)/\1/p' /etc/companies.d/${com_id}/msmtprc);
		[ -n "$fromline" ] && \
			sed "s/\(From:.*<\)\(pbxservice.*\)>/\1$fromline>/" $MAILFILE | $SUDO tee $MAILFILE >/dev/null;
	fi
	NBASE=$(sed -ne 's/@/[at]/g;s/\s/~/g;s/.*--\~\(.*\)/\1/p;' "$MSMTPFILE")

else
	# mutt version: msmtp-enqueue.sh 0 -- email@domain.com
    echo "$@" | awk '$1 != "--" { $1 = "";} {print $0}' > "$MSMTPFILE"
	NBASE=$(echo "$@" | sed -ne 's/@/[at]/g;s/\s/~/g;s/.*--\~\(.*\)/\1/p;')
fi

$SUDO mv {${BASE},${P}_${NBASE}_${BASE}}.msmtp
$SUDO mv {${BASE},${P}_${NBASE}_${BASE}}.mail

msmtp-runqueue.sh > /dev/null &

exit 0